#ifndef _FILE_H_
#define _FILE_H_

#include "List.h"

class CFile
{
	public:
    
    CFile(){}
		
		//////////////////////////////////////////////////////////////////////////
		//Function:LoadFile( PCSTR fileName )
		//Purpose	:LoadFile data from file to the list
		//Param		:PCSTR fileName - file name from which will be data read
		//return  : bool - true if success, false if failed
		bool LoadFile(PCSTR fileName)
		{
			char buff[ItemSize];
			DWORD dwMaxLen = sizeof(buff);
			
			HANDLE hFile = CreateFile(TEXT(fileName),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);                 // no attr. template
			
			if (hFile == INVALID_HANDLE_VALUE) 
			{ 
				printf("Could not open file (error %d)\n", GetLastError());
				return false;
			}
			
			DWORD	dwMax		= dwMaxLen;
			Contact * person	= 0;	
			BYTE	founded		= 0;		//counter of ";" which was founded
			int		rest		= 0;		//rest of chars
			
			
			while ( ReadFile( hFile,buff+rest, dwMax, &dwMax,NULL  ) )
			{
				if( !dwMax || GetLastError() == ERROR_HANDLE_EOF )
					break;
				
				WORD idx = rest;

				for( DWORD i = rest; i < dwMax+rest; i++ )
				{
					if( buff[ i ] == ';' )
					{
						buff[ i ] = 0;		// replace ";" by 0
						
						if( !founded )
							person = new Contact( );		//allocate new Contact
 						
						person->SetParam( (BYTE)founded, (buff+i)-idx );
						
						idx = 0;		//reset index
						
						if( founded++ == Contact::Total )		//record is loaded
						{
							m_list.InsertToEnd( person );
							founded	= 0;		//reset counter of ";"
						}	
					}	
				
				if( buff[i]!=0 && buff[i]!=0x0D && buff[i]!=0x0A )	//dont move if end of line or if 0
					idx++;
				}

				rest = idx;
				
				if( founded ) //if record was loaded yet, copy rest of record to the beginning of array
				{
					memcpy(buff, (buff+i)-idx , rest  );
				}
				
				dwMax = dwMaxLen - rest;//recount rest of free bytes for reading
			}
			
			CloseHandle(hFile);
			return true;
		}


		
		//////////////////////////////////////////////////////////////////////////
		//Function:SaveFile( PCSTR fileName )
		//Purpose	:Save data from list to the file
		//Param		:PCSTR fileName - file name where will be data written
		//return  : bool - true if success, false if failed
		bool SaveFile( PCSTR fileName )
		{
			_ASSERT ( fileName );			

      
			HANDLE file = CreateFile( TEXT(fileName), GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			if( file == INVALID_HANDLE_VALUE )
			{
				printf("Could not open file (error %d)\n", GetLastError());
				return false;
			}	
			
			char buff[512];
	    bool ret = true;
      Contact * person;
      
      while( person = m_list.GetNextData() )
   		{
			//clear buffer
				ZeroMemory(buff, sizeof(buff));
        
			//format buffer
				for( int i = 0; i <= Contact::Total; i++ )
        {
          _snprintf( buff+strlen(buff), sizeof(buff) - strlen(buff),"%s;",person->GetParam(i) );
        }
				
			//insert end of line
				buff[strlen(buff)]    = 0x0D;
				buff[strlen(buff)+1]  = 0x0A;


        DWORD dwLen = strlen(buff);
			//write data
        if( !WriteFile( file, buff, dwLen, &dwLen,NULL  ) )
        {
          ret = false;
          break;
        }
      }
			
			CloseHandle(file);
			
			return ret;
		}
    
			//reuturn pointer to list
    List * GetList() { return &m_list; }
		
private:
	List    m_list;  
};
#endif