#include <cstdlib>
#include <iostream>
#include "List.h"


void Problem()
{
	printf("Nedostatek pameti");
	exit(1);
}

//////////////////////////////////////////////////////////////////////////
//Function:Constructor - create and prepare data
List::List()
{					
	m_Begin = new ContactItem(0); 
	
	if (!m_Begin) 
		Problem(); 
	else 
		m_Temp = m_Begin;
}

//////////////////////////////////////////////////////////////////////////
//Function:Desctructor - destroy all
List::~List()
{
	DeleteAll();		
	delete m_Temp;		
}

//////////////////////////////////////////////////////////////////////////
//Function:DeleteAll()
//Purpose	:Destroy all items of LIST
void List::DeleteAll()
{
	while (m_Begin != m_Temp)
	{
		ContactItem * p = m_Begin;
		m_Begin			= m_Begin ->GetNext();
		delete p;
	}
}

//////////////////////////////////////////////////////////////////////////
//Function:GetNextData( bool reset /*= false*/)
//Purpose	:returns pointer to next data
//Param		:bool reset - default false, if true - List will start from beginning
//return  :bool - true if success, false if failed
Contact *	List::GetNextData( bool reset /*= false*/)
{

	static ContactItem * next = m_Begin;

	Contact * tmp = 0;
	
	if( reset | !next )
		next = m_Begin;

	if( next )
	{
		tmp		= next->GetData();
		next	= next->GetNext();
		
	}	
	return tmp;
}

//////////////////////////////////////////////////////////////////////////
//Function:InsertToEnd(T d)	
//Purpose	:Insert data T into List
//Param		:T d - data to be inserted
//return  :bool - true if success, false if failed
bool List::InsertToEnd(T d)	
{									
	ContactItem *p = new ContactItem(0);			
	
	if (p)							
	{
		m_Temp	->	SetNext(p);		
		m_Temp	->	SetData( d );
		m_Temp	=	p;
	}
	return p ? true:false;
}

//////////////////////////////////////////////////////////////////////////
//Function:SeekData( BYTE bName, char * find )	
//Purpose	:Seek data according parameter of Item and return pointer to class Contact
//Param		:BYTE bName - type of data to be find, char * find - value to find
//return  :bool - true if success, false if failed
Contact * List::SeekData( BYTE bName, char * find )	
{											
	ContactItem * p	=	m_Begin;
	
	while ( p )
	{
		const char * founded = p->GetData()->GetParam(bName);
		
		if( founded && strlen( founded  ) == strlen( find ) && !strnicmp(founded, find, strlen(founded) ) )
		{
			return p->GetData();
		}	
		p = p->GetNext();
	}
	return 0;
	
}

//////////////////////////////////////////////////////////////////////////
//Function:Seek( T d, ContactItem *& pred)	
//Purpose	:Find data in List according a pointer do data
//return  :ContactItem * - if founded, else 0
List::ContactItem * List::Seek( T d, ContactItem *& pred)	
{											
	
	ContactItem *p	=	m_Begin;
	pred						= 0;
	m_Temp ->SetData(d);
	while (p->GetData() != d)
	{
		pred	= p;
		p		= p->GetNext();
	}
	
	if (p == m_Temp) 
		return 0;
	else 
		return p;
}

//////////////////////////////////////////////////////////////////////////
//Function:Remove( T d )
//Purpose	:Remove data eccording data value T
//Param		:T d - data to be removed
//return  :bool - true if success, false if failed
bool List::Remove( T d )
{
	ContactItem * pred, *p;
	
	if ( p = Seek(d, pred) )
	{
		if( pred )
			pred->SetNext(p->GetNext());
		else 
			m_Begin = p->GetNext();
		delete p;
		return true;
	}
	return false;
}
