#ifndef _LIST_H_
#define _LIST_H_

#include "Person.h"

//////////////////////////////////////////////////////////////////////////
//Class: List
//Descr: jednostrane zretezeny seznam
class List
{

	template<class T>
	class Item
	{
	
	public:
		Item( T d = 0):m_Data(d), m_Next(0){}			
		void		SetData( T d )		{	m_Data=d;	}	
		T			GetData() 			{ return m_Data;}
		void		SetNext(Item * p) 	{	m_Next = p;	}
		Item*		GetNext()			{ return m_Next; }
		
	private:
		T			m_Data;			//data ktere chceme uchovat
		Item *		m_Next;			//ukazatel na dalsi prvek	
	};

public:
	typedef Contact * T;
	typedef Item<T> ContactItem;

	List();						
	~List();
	
	bool				InsertToEnd( T d ); 
	Contact *			SeekData( BYTE bName, char * find )	;
	ContactItem *		Seek( T d, ContactItem *& pred);
	bool				Remove( T d );
	void				DeleteAll();

	Contact *			GetNextData( bool reset= false );


private:

	ContactItem *	m_Begin;			 //pointer to begin of Item
	ContactItem *	m_Temp;              //helper pointer
};

void Problem();

#endif
